Next: Descriptor data structure Up: userhtml Previous: Programming model Contents

#
Data Structures and Classes

In this chapter we illustrate the data structures used for definition of routines interfaces. They include data structures for sparse matrices, communication descriptors and preconditioners.

All the data types and the basic subroutine interfaces related to descriptors and sparse matrices are defined in the module `psb_base_mod`; this will have to be included by every user subroutine that makes use of the library. The preconditioners are defined in the module `psb_prec_mod`

Real and complex data types are parametrized with a kind type defined in the library as follows:

psb_spk_
  Kind parameter for short precision real and complex data; corresponds to a `REAL` declaration and is normally 4 bytes.
psb_dpk_
  Kind parameter for long precision real and complex data; corresponds to a `DOUBLE PRECISION` declaration and is normally 8 bytes.
psb_long_int_k_
  Kind parameter for long integers, used by the `psb_sizeof` utility.

Together with the classes attributes we also discuss their methods. Most methods detailed here only act on the local variable, i.e. their action is purely local and asynchronous unless otherwise stated. The list of methods here is not completely exhaustive; many methods, especially those that alter the contents of the various objects, are usually not needed by the end-user, and therefore are described in the developer's documentation.

Subsections

- Descriptor data structure
  - Methods
  - get_local_rows -- Get number of local rows
  - get_local_cols -- Get number of local cols
  - get_global_rows -- Get number of global rows
  - get_global_cols -- Get number of global cols
- get_context--Get communication context
  - psb_cd_get_large_threshold -- Get threshold for index mapping switch
  - psb_cd_set_large_threshold -- Set threshold for index mapping switch
  - Named Constants
- Sparse Matrix class
  - Methods
  - get_nrows -- Get number of rows in a sparse matrix
  - get_ncols -- Get number of columns in a sparse matrix
  - get_nnzeros -- Get number of nonzero elements in a sparse matrix
  - get_size -- Get maximum number of nonzero elements in a sparse matrix
  - sizeof -- Get memory occupation in bytes of a sparse matrix
  - get_fmt -- Short description of the dynamic type
  - is_bld, is_upd, is_asb -- Status check
  - Named Constants
- Dense Vector Data Structure
  - Methods
  - get_nrows -- Get number of rows in a dense vector
  - get_ncols -- Get number of columns in a sparse matrix
  - sizeof -- Get memory occupation in bytes of a dense vector matrix
  - get_vect -- Get a copy of the vector contents
- Preconditioner data structure
- Data structure Methods

Next: Descriptor data structure Up: userhtml Previous: Programming model Contents